<template>
  <div>
    <div class="add-bonus">
      <ob-checkbox
        class="add-bonus__header"
        :label="'Включить бонусы за длительности пребывания в коридорах значений рейтинга'"
        :v-model="addDuration"
      />
      <span class="add-bonus__header">Длительности пребывания в коридорах значений рейтинга</span>
      <div class="add-bonus__container">
        <!-- <p>Количество интервалов -->
          <ob-input
            class="add-bonus__input"
            :label="'Количество интервалов'"
            :placehodler="'Введите'"
            :disabled="this.addDuration"
            type="text"
            v-model="addValue"
            @input="addDurationValue"
          />
        <!-- </p> -->
        <!-- <p>Период начисления -->
          <ob-input
            class="add-bonus__input"
            :label="'Количество начисления дней'"
            :placeholder="'Введите'"
            :disabled="addDuration"
            type="text"
          />
        <!-- </p> -->
        <div class="table">
            <div class="table__row" v-for="item in addValue * 1" :key="item">
                <ob-input
                    class="item"
                    :label="'Минимальный период'"
                    :placeholder="'Введите значение'"
                    type="text"
                />
                <ob-input
                    class="item"
                    :label="'Значение рейтинга'"
                    :placeholder="'Введите значение'"
                    type="text"
                />
                <ob-input
                    class="item"
                    :label="'Количество бонусов'"
                    :placeholder="'Введите значение'"
                    type="text"
                />
            </div>
        </div>
        <!-- <table-rate :items="duration" :counts="true" :value="slicedDurationValues"/> -->
      </div>
    </div>

    <div class="add-bonus">
      <ob-checkbox
        class="add-bonus__header"
        :label="'Включить бонусы за повышение рейтинга'"
        :value="addIncrease"
      />
      <span class="add-bonus__header">Коридоры повышения рейтинга</span>
      <div class="add-bonus__container">
        <p>Количество интервалов
          <ob-input
            class="add-bonus__input"
            :label="''"
            :isDisabled="addIncrease"
            type="text"
            v-model="upgrade"
            @input="addIncreaseValue"
          />
        </p>
        <p>Память о переходах
          <ob-input
            class="add-bonus__input"
            :label="''"
            :value="''"
            :isDisabled="addIncrease"
            type="text"
          />дней
        </p>
        <div class="table">
            <div class="table__row" v-for="item in upgrade * 1" :key="item">
                <ob-input
                    class="double"
                    :label="'Минимальный период'"
                    :placeholder="'Введите значение'"
                    type="text"
                />
                <ob-input
                    class="double"
                    :label="'Значение рейтинга'"
                    :placeholder="'Введите значение'"
                    type="text"
                />
            </div>
        </div>
        <!-- <table-rate :double="true" :items="increase" :counts="true" :value="slicedIncreaseValues"/> -->
      </div>
    </div>

    <div class="add-bonus">
      <ob-checkbox
        class="add-bonus__header"
        :label="'Включить бонусы за выполнение заказов'"
        :value="addComplete"
      />
      <span class="add-bonus__header">Коридоры выполнение заказов</span>
      <div class="add-bonus__container">
        <p>Количество интервалов
          <ob-input
            class="add-bonus__input"
            :label="''"
            :isDisabled="addComplete"
            type="text"
            v-model="complete"
            @input="addCompleteValue"
          />
        </p>
        <div class="table">
            <div class="table__row" v-for="item in complete * 1" :key="item">
                <ob-input
                    class="double"
                    :label="'Минимальный период'"
                    :placeholder="'Введите значение'"
                    type="text"
                />
                <ob-input
                    class="double"
                    :label="'Значение рейтинга'"
                    :placeholder="'Введите значение'"
                    type="text"
                />
            </div>
        </div>
        <!-- <table-rate :double="true" :items="increase" :counts="true" :value="slicedCompleteValues"/> -->
      </div>
    </div>
    <button @click="save"> Save </button>
  </div>
</template>

<script>
import ObCheckbox from "common-components/src/obComponents/obCheckbox";
import ObInput from "common-components/src/obComponents/obInput";
import { UPDATE_METHODOLOGY } from '../../../store/modules/bonus_methodology';

export default {
  data() {
    return {
      addValue: 1,
      upgrade: 1,
      complete: 1,
      addDuration: false,
      duration: [
        {
          value: 'Минимальный период',
          field: 'title',
          name: 'min'
        },
        {
          value: 'Значение рейтинга',
          field: 'title',
          name: 'ratings',
        },
        {
          value: 'Количество бонусов',
          field: 'title',
          name: 'max',
        }
      ],
      array: [
        {
          min: 0,
          rating: 0,
          bonus: 0
        },
        {
          min: 0,
          rating: 0,
          bonus: 0
        },
        {
          min: 0,
          rating: 0,
          bonus: 0
        },
        {
          min: 0,
          rating: 0,
          bonus: 0
        }
      ],
      notArray: [
        {
          min: 0,
          rating: 0
        },
      ],
      comArray: [
        {
          min: 0,
          rating: 0
        },
      ],
      increase: [
        {
          value: 'Значение рейтинга',
          field: 'title',
        },
        {
          value: 'Количество бонусов',
          field: 'title',
        }
      ],
      slicedDurationValues: [],
      slicedIncreaseValues: [],
      slicedCompleteValues: []
    }
  },
  components: {
    ObCheckbox,
    ObInput,
    // tableRate,
    // tableOne
  },
  methods: {
    addDurationValue(val) {
      const slicedDurationValues = this.array.slice(0, val);
      console.log('slicedDurationValues')
      console.log(slicedDurationValues)
      const arr = [];
      slicedDurationValues.forEach(item => {
        for (let key in item) {
            arr.push({value: item[key], name: key});
        }
      })
      console.log('arr')
      console.log(arr)
      this.slicedDurationValues = arr
    },
    addIncreaseValue(val) {
      const slicedIncreaseValues = this.notArray.slice(0, val);
      console.log('slicedIncreaseValues')
      console.log(slicedIncreaseValues)
      const arr = [];
      slicedIncreaseValues.forEach(item => {
        for (let key in item) {
            arr.push({value: item[key], name: key});
        }
      })
      console.log('arr')
      console.log(arr)
      this.slicedIncreaseValues = arr
    },
    addCompleteValue(val) {
      const slicedCompleteValues = this.comArray.slice(0, val);
      console.log('slicedCompleteValues')
      console.log(slicedCompleteValues)
      const arr = [];
      slicedCompleteValues.forEach(item => {
        for (let key in item) {
            arr.push({value: item[key], name: key});
        }
      })
      console.log('arr')
      console.log(arr)
      this.slicedCompleteValues = arr
    },
    save() {
      const payload = {
                // uuid: this.current.uuid,
                // name: this.current.name,
                // description: this.current.description,
                // participantActivityUuid: this.current.participantActivityUuid,
                // status: this.current.status,
                algorithms: {
                    inRangeValues: {
                      values: dur
                      // period: this.current.algorithms.inRangeValues.period
                    },
                    // ratingIncrease: {
                    //     // transitionMember: this.current.algorithms.ratingIncrease.transitionMember
                    // }
                }
            }
            try {
                this.$store.dispatch(UPDATE_METHODOLOGY, payload)
                console.log('payload')
                console.log(payload)
            } catch (ex) {
                console.log(ex)
            }
      var row = -1;
      var arow = -1;
      var brow = -1;
      var valuesss = [];
      var dur = [];
      var inc = [];
      var com = [];
      this.slicedDurationValues.forEach((item, index) => {
        if ((index) % 3 === 0) {
          dur.push({[item.name]: item.value});
          row++;
        } else {
          dur[row][item.name] = item.value
        }

      })
      console.log('dur')
      console.log(dur)
      this.slicedIncreaseValues.forEach((item, index) => {
        if ((index) % 2 === 0) {
          inc.push({[item.name]: item.value});
          arow++;
        } else {
          inc[arow][item.name] = item.value
        }

      })
      console.log('inc')
      console.log(inc)
      this.slicedCompleteValues.forEach((item, index) => {
        if ((index) % 2 === 0) {
          com.push({[item.name]: item.value});
          brow++;
        } else {
          com[brow][item.name] = item.value
        }

      })
      console.log('com')
      console.log(com)
      // let valuesss
      valuesss.push(dur)
      console.log('values')
      console.log(valuesss)
      console.log('payload')
                console.log(payload)
      // this.algorithms.inRangeValues.values.push(dur)
      // this.algorithms.ratingIncrease.values.push(inc)
      // this.algorithms.ratingIncrease.values.push(com)
      // console.log('inRangeValues')
      // console.log(this.algorithms.inRangeValues.values)

      
    }
  },
  // computed: {
  //   current() {
  //     return this.$store.getters.getCurrentMethodology;
  //   }
  // }
}
</script>

<style lang="scss">
.add-bonus {
  display: flex;
  flex-direction: column;
  padding: 0 10px;

  &__container {
    p {
      display: flex;
      align-items: center;
      width: 50%;
    }
    justify-content: space-around;
    display: flex;
    flex-wrap: wrap;
    border: 1px solid #D1D2D6;
    padding: 10px
  }
  &__input {
    // width: 60px;
    // margin: 0 20px;
    margin-bottom: 10px;
  }
  &__header {
    padding: 10px 0;
  }
}
.table {
    display: flex;
    flex-wrap: wrap;
    width: 100%;
    &__row {
        width: 100%;
        display: flex;
        flex-wrap: wrap;
        .item {
            width: 33.33%;
        }
        .double{ 
            width: 50%;
        }
    }
    &__header {
        width: 100%;
    }
}
</style>
